<?php
/*
Plugin Name: diigoRSS
Plugin URI: http://www.paulcormack.net/projects#diigoRSS
Description: Integrates a diigo bookmark RSS feed into your blog.
Version: 0.7
License: GPLV2
Author: Paul Cormack
Author URI: http://www.paulcormack.net
*/

class diigoRSS extends WP_Widget {
	function diigoRSS() {
		$widget_ops = array( 'classname' => 'widget_diigoRSS', 'description' => __( "A diigo bookmark RSS parser." ) );
		$this->WP_Widget('diigoRSS', __('diigoRSS'), $widget_ops);
	}

	function widget($args, $instance) {
		extract($args);	
		$diigoRSS_before = '<ul class="diigoRSS">';
		$diigoRSS_after = '</ul>';
		echo $before_widget;
		if(!empty($instance['title'])) echo $before_title . $instance['title'] . $after_title;
		if(empty($instance['user'])) $instance['user'] = 'eightcell';
		if(empty($instance['bm_limit'])) $instance['bm_limit'] = 5;
		if(empty($instance['link_back'])) $instance['link_back'] = 0;
		$diigoRSS_feed = 'http://www.diigo.com/rss/user/' . $instance['user'];
		$diigoRSS_profile = 'http://www.diigo.com/user/' . $instance['user'];
		if (!function_exists('MagpieRSS')) include_once (ABSPATH . WPINC . '/rss.php');
		$diigoRSS_content = @fetch_rss($diigoRSS_feed);
		
		if ($diigoRSS_content) {
			$diigoRSS_content = array_slice($diigoRSS_content->items, 0, $instance['bm_limit']);
			echo $diigoRSS_before;
			foreach ($diigoRSS_content as $item) {
				$diigoRSS_heading = $item['title'];				
				echo '<li><a href="' . $item['link'] . '" class="diigoRSS" title="' . 
					$item['title'] . '" alt="' . $item['title'] . '" target="_blank">' . 
					$item['title'] . '</a></li>';	 
			}
			echo $diigoRSS_after;
			
			if ($instance['link_back']) {
				echo '<div class="diigoRSS_more"><a href="' . $diigoRSS_profile . 
					'" alt="More" title="More" target="_blank">More...</a></div>';
            }
		}
		else {
			echo "RSS problems, check diigo username...\n";
			echo $diigoRSS_feed;
		}
		echo $after_widget;
	}

	function update($new_instance, $old_instance) {
		return $new_instance;
	}

	function form($instance) {
		echo '<div id="diigoRSS-admin-panel">';
		echo '<p><label for="' . $this->get_field_id('title') . 
			'">Widget title:</label>';
		echo '<input type="text" class="widefat" ';
		echo 'name="' . $this->get_field_name('title') . '" '; 
		echo 'id="' . $this->get_field_id('title') . '" ';
		echo 'value="' . $instance['title'] . '" /></p>';
		echo '<p><label for="' . $this->get_field_id('user') . 
			'">diigo username:</label>';
		echo '<input type="text" class="widefat" ';
		echo 'name="' . $this->get_field_name('user') . '" '; 
		echo 'id="' . $this->get_field_id("user") . '" ';
		echo 'value="' . $instance['user'] . '" /></p>';
		echo '<p><label for="' . $this->get_field_id('bm_limit') . 
			'">How many bookmarks?</label><br />';
		echo '<select id="' . $this->get_field_id('bm_limit') . 
			'" name="' . $this->get_field_name('bm_limit') . 
			'" class="widefat">';
		for ($i=1; $i<=20; $i++) {
			echo '<option value="' . $i . '"';
			if ( $i == $instance['bm_limit'] ) echo ' selected="selected"';
			echo '">' . $i . '</option>';
		}
		echo '</select></p>';
		echo '<p><label for="' . $this->get_field_id('link_back') . 
			'">Add link to diigo account?</label><br />';
		echo '<select id="' . $this->get_field_id('link_back') . 
			'" name="' . $this->get_field_name('link_back') . 
			'" class="widefat">';
		echo '<option value="0" '; 
			if ( $instance['link_back'] === 0 ) echo 'selected="selected"';
		echo '">Off</option><option value="1" ';
			if ( $instance['link_back'] == 1 ) echo 'selected="selected"';
		echo '">On</option></select></p>';
		echo '</div>';
	} 
}
add_action('widgets_init', create_function('', 'return register_widget("diigoRSS");'));

?>
